<?php

## turns plain quotes into smart quotes; special case of `' gives a right quote
## turns -- into an em dash and << ... >> into angle quotes
## and generally tries to make pages look more attractive
##
## Copyright 2003 John Rankin (john.rankin@affinity.co.nz)

$InlineReplacements["/--/"]="&mdash;";
$InlineReplacements["/`-/"]="&ndash;";
$InlineReplacements["/([0-9])-([0-9])/"]="$1&ndash;$2";
$InlineReplacements["/-&gt;/"]="&rarr;";
$InlineReplacements["/&lt;-/"]="&larr;";
$InlineReplacements["/\.\.\./"]="&hellip;";
$InlineReplacements["/\+\/?\-/"]="&plusmn;";
$InlineReplacements["/&lt;&lt;(.*?)&gt;&gt;/"]="&laquo;$1&raquo;";
$InlineReplacements["/&lt;(.*?)\|/"]="&lsaquo;$1|";
$InlineReplacements["/\|(.*?)&gt;/"]="|$1&rsaquo;";
$InlineReplacements["/(<.*?>['\"]*)|((.?)(['\"]+))/e"] = 
    'BypassHTML("$1","$2")';

function BypassHTML($hstring,$qstring) {
  if ($qstring=='') {
     $qstring = preg_replace("/.*>/",'',$hstring);
     $hstr = stripslashes(preg_replace("/>.*/",'>',$hstring));
     if ($qstring=='') return $hstr;
     else { if (strstr($hstr,"</")) $qstring = "`" . $qstring;
            return $hstr . SmartenQuotes(stripslashes($qstring)); }
  }
  else return SmartenQuotes(stripslashes($qstring));
}

function SmartenQuotes($chars) {
  $s = 0;  $r = '';
  if ($chars[0] =="'" || $chars[0] == '"') {
      $quotes = $chars;
      $char = '';
  } else {
      $quotes = substr($chars,1);
      $char = $chars[0];
      if (strstr("0123456789",$char)) {
         if ($quotes[0]=="'") $p = "p";
         else $p = "P";
         $r = "$char&$p" . "rime;";
         $s = 1;
         $char = "`";
      }
  }
  $hands = array('l','r');
  if ($char=="" || strstr(" =-[(",$char)) $hi = 0;
  else $hi = 1;
  if ($char=="`") $char = "";
  $r .= $char;
  $prevq = "x";
  for ($i=$s;$i<strlen($quotes);$i++) {
      if ($quotes[$i]=="'") $q = "s";
      else $q = "d";
      if ($q==$prevq) $hi = 1 - $hi;
      $r .= "&$hands[$hi]$q" . "quo;";
      $prevq = $q;
  }
  return $r;
}

?>
